LAMP

httpd 2.4.18 + mysql-5.5.33 + php-5.4.26编译安装过程:

一、编译安装apache
1、解决依赖关系
httpd-2.4.18需要较新版本的apr和apr-util,因此需要事先对其进行升级。升级方式有两种,一种是通过源代码编译安装,一种是直接升级rpm包。这里选择使用编译源代码的方式进行,它们的下载路径为ftp://172.16.0.1/pub/Sources/new_lamp。
(1) 编译安装apr
tar xf apr-1.5.2.tar.bz2
cd apr-1.5.2
./configure --prefix=/usr/local/apr
make && make install
(2) 编译安装apr-util

tar xf apr-util-1.5.4.tar.bz2
cd apr-util-1.5.4
./configure --prefix=/usr/local/apr-util --with-apr=/usr/local/apr
make && make install

附:apache官方对APR的介绍:

The mission of the Apache Portable Runtime (APR) project is to create and maintain software libraries that provide a predictable and consistent interface to underlying platform-specific implementations. The primary goal is to provide an API to which software developers may code and be assured of predictable if not identical behaviour regardless of the platform on which their software is built, relieving them of the need to code special-case conditions to work around or take advantage of platform-specific deficiencies or features.


(3) httpd-2.4.18编译过程也要依赖于pcre-devel软件包,需要事先安装。

tar xf pcre-8.36.tar.gz 
cd pcre-8.36/
./configure --prefix=/usr/local/pcre
make && make install

2、编译安装httpd-2.4.18

首先下载httpd-2.4.18到本地。而后执行如下命令进行编译安装过程:

tar xf httpd-2.4.18.tar.bz2
cd httpd-2.4.18
./configure \
--prefix=/usr/local/httpd \
--sysconfdir=/etc/httpd \
--enable-so --enable-ssl  \
--enable-cgi --enable-rewrite \
--with-zlib --with-pcre=/usr/local/pcre \
--with-apr=/usr/local/apr \
--with-apr-util=/usr/local/apr-util \
--enable-mods-shared=most --enable-mpms-shared=all \
--with-mpm=event
 make && make install
选项解释:
--prefix=/usr/local/httpd    # 指定安装目录
--sysconfdir=/etc/httpd    # 指定配置文件安装路径
--enable-so --enable-ssl  #允许运行时加载DSO模块 # 启动ssl加密功能
--enable-cgi --enable-rewrite  # 启用cgi协议  #启用URL重写功能 
--with-zlib --with-pcre   # 指定pcre的安装路径  
--with-apr=/usr/local/apr   #指定apr的安装路径
--with-apr-util=/usr/local/apr-util   # 指定apr-util的安装路径
--enable-modules=most   # 启用大多数共享模块
--enable-mpms-shared=most  #启用MPM大多数参数
--with-mpm=event  #指定使用的MPM的类型


httpd编译安装常见错误:

checking for OpenSSL version >= 0.9.8a... FAILED
configure: WARNING: OpenSSL version is too old
no
checking whether to enable mod_ssl... configure: error: mod_ssl has been requested but can not be built due to prerequisite failures


原因:
缺少openssl-devel包
yum install openssl-devel

安装完openssl-devel后编译安装httpd 
--with-ssl可以指明路径也可以不指
如果要指,可以通过下面命令查看

#openssl version -a
OpenSSL 1.0.1e-fips 11 Feb 2013
built on: Mon Feb 20 14:38:48 UTC 2017
platform: linux-x86_64
options:  bn(64,64) md2(int) rc4(16x,int) des(idx,cisc,16,int) idea(int) blowfish(idx) 
compiler: gcc -fPIC -DOPENSSL_PIC -DZLIB -DOPENSSL_THREADS -D_REENTRANT -DDSO_DLFCN -DHAVE_DLFCN_H -DKRB5_MIT -m64 -DL_ENDIAN -DTERMIO -Wall -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches   -m64 -mtune=generic -Wa,--noexecstack -DPURIFY -DOPENSSL_IA32_SSE2 -DOPENSSL_BN_ASM_MONT -DOPENSSL_BN_ASM_MONT5 -DOPENSSL_BN_ASM_GF2m -DSHA1_ASM -DSHA256_ASM -DSHA512_ASM -DMD5_ASM -DAES_ASM -DVPAES_ASM -DBSAES_ASM -DWHIRLPOOL_ASM -DGHASH_ASM
OPENSSLDIR: "/etc/pki/tls"
engines:  dynamic

--with-ssl=/etc/pki/tls

补充:

(1)构建MPM为静态模块
在全部平台中,MPM都可以构建为静态模块。在构建时选择一种MPM,链接到服务器中。如果要改变MPM,必须重新构建。为了使用指定的MPM,请在执行configure脚本 时,使用参数 --with-mpm=NAME。NAME是指定的MPM名称。编译完成后,可以使用 ./httpd -l 来确定选择的MPM。 此命令会列出编译到服务器程序中的所有模块,包括 MPM。

(2)构建 MPM 为动态模块
在Unix或类似平台中,MPM可以构建为动态模块,与其它动态模块一样在运行时加载。 构建 MPM 为动态模块允许通过修改LoadModule指令内容来改变MPM,而不用重新构建服务器程序。在执行configure脚本时,使用--enable-mpms-shared选项即可启用此特性。当给出的参数为all时,所有此平台支持的MPM模块都会被安装。还可以在参数中给出模块列表。默认MPM,可以自动选择或者在执行configure脚本时通过--with-mpm选项来指定,然后出现在生成的服务器配置文件中。编辑LoadModule指令内容可以选择不同的MPM。

3、修改httpd的主配置文件,设置其Pid文件的路径
编辑/etc/httpd/httpd.conf,添加如下行即可:
PidFile  "/var/run/httpd.pid"


4、提供SysV服务脚本/etc/rc.d/init.d/httpd,内容如下:


#!/bin/bash
#
# httpd        Startup script for the Apache HTTP Server
#
# chkconfig: - 85 15
# description: Apache is a World Wide Web server.  It is used to serve \
#        HTML files and CGI.
# processname: httpd
# config: /etc/httpd/conf/httpd.conf
# config: /etc/sysconfig/httpd
# pidfile: /var/run/httpd.pid

# Source function library.
. /etc/rc.d/init.d/functions


if [ -f /etc/sysconfig/httpd ]; then
        . /etc/sysconfig/httpd
fi

# Start httpd in the C locale by default.
HTTPD_LANG=${HTTPD_LANG-"C"}

# This will prevent initlog from swallowing up a pass-phrase prompt if
# mod_ssl needs a pass-phrase from the user.
INITLOG_ARGS=""

# Set HTTPD=/usr/sbin/httpd.worker in /etc/sysconfig/httpd to use a server
# with the thread-based "worker" MPM; BE WARNED that some modules may not
# work correctly with a thread-based MPM; notably PHP will refuse to start.

# Path to the apachectl script, server binary, and short-form for messages.
apachectl=/usr/local/httpd/bin/apachectl
httpd=${HTTPD-/usr/local/httpd/bin/httpd}
prog=httpd
pidfile=${PIDFILE-/var/run/httpd.pid}
lockfile=${LOCKFILE-/var/lock/subsys/httpd}
RETVAL=0

start() {
        echo -n $"Starting $prog: "
        LANG=$HTTPD_LANG daemon --pidfile=${pidfile} $httpd $OPTIONS
        RETVAL=$?
        echo
        [ $RETVAL = 0 ] && touch ${lockfile}
        return $RETVAL
}


stop() {
  echo -n $"Stopping $prog: "
  killproc -p ${pidfile} -d 10 $httpd
  RETVAL=$?
  echo
  [ $RETVAL = 0 ] && rm -f ${lockfile} ${pidfile}
}
reload() {
    echo -n $"Reloading $prog: "
    if ! LANG=$HTTPD_LANG $httpd $OPTIONS -t >&/dev/null; then
        RETVAL=$?
        echo $"not reloading due to configuration syntax error"
        failure $"not reloading $httpd due to configuration syntax error"
    else
        killproc -p ${pidfile} $httpd -HUP
        RETVAL=$?
    fi
    echo
}


# See how we were called.
case "$1" in
  start)
  start
  ;;
  stop)
  stop
  ;;
  status)
        status -p ${pidfile} $httpd
  RETVAL=$?
  ;;
  restart)
  stop
  start
  ;;
  condrestart)
  if [ -f ${pidfile} ] ; then
    stop
    start
  fi
  ;;
  reload)
        reload
  ;;
  graceful|help|configtest|fullstatus)
  $apachectl $@
  RETVAL=$?
  ;;
  *)
  echo $"Usage: $prog {start|stop|restart|condrestart|reload|status|fullstatus|graceful|help|configtest}"
  exit 1
esac


exit $RETVAL

而后为此脚本赋予执行权限:
# chmod +x /etc/rc.d/init.d/httpd
加入服务列表:
# chkconfig --add httpd

接下来就可以启动服务进行测试了。

二、安装mysql-5.5.33

1、准备数据存放的文件系统

新建一个逻辑卷,并将其挂载至特定目录即可。这里不再给出过程。

这里假设其逻辑卷的挂载目录为/mydata,而后需要创建/mydata/data目录做为mysql数据的存放目录。

2、新建用户以安全方式运行进程:

# groupadd -r mysql
# useradd -g mysql -r -s /sbin/nologin -M -d /mydata/data mysql
# chown -R mysql:mysql /mydata/data


3、安装并初始化mysql-5.5.33

首先下载平台对应的mysql版本至本地,这里是32位平台,因此,选择的为mysql-5.5.33-linux2.6-i686.tar.gz,其下载位置为ftp://172.16.0.1/pub/Sources/mysql-5.5。


# tar xf mysql-5.5.33-linux2.6-i686.tar.gz -C /usr/local
# cd /usr/local/
# ln -sv mysql-5.5.33-linux2.6-i686  mysql
# cd mysql 

# chown -R mysql:mysql  .
# scripts/mysql_install_db --user=mysql --datadir=/mydata/data
# chown -R root  .

4、为mysql提供主配置文件:

# cd /usr/local/mysql
# cp support-files/my-large.cnf  /etc/my.cnf
并修改此文件中thread_concurrency的值为你的CPU个数乘以2,比如这里使用如下行:
thread_concurrency = 2

另外还需要添加如下行指定mysql数据文件的存放位置:
datadir = /mydata/data

5、为mysql提供sysv服务脚本:

# cd /usr/local/mysql
# cp support-files/mysql.server  /etc/rc.d/init.d/mysqld
# chmod +x /etc/rc.d/init.d/mysqld

添加至服务列表:
# chkconfig --add mysqld
# chkconfig mysqld on

而后就可以启动服务测试使用了。

为了使用mysql的安装符合系统使用规范,并将其开发组件导出给系统使用,这里还需要进行如下步骤:
6、输出mysql的man手册至man命令的查找路径:
编辑/etc/man.config,添加如下行即可:
MANPATH  /usr/local/mysql/man

7、输出mysql的头文件至系统头文件路径/usr/include:

这可以通过简单的创建链接实现:
# ln -sv /usr/local/mysql/include  /usr/include/mysql

8、输出mysql的库文件给系统库查找路径:

# echo '/usr/local/mysql/lib' > /etc/ld.so.conf.d/mysql.conf
而后让系统重新载入系统库:
# ldconfig


9、修改PATH环境变量,让系统可以直接使用mysql的相关命令。具体实现过程这里不再给出。
/etc/porfile文件的最后加一段

# vim /etc/profile

declare -x PATH="/usr/local/mysql/client:$PATH"

# source /etc/profile


三、编译安装php-5.4.26


1、解决依赖关系:

请配置好yum源(系统安装源及epel源)后执行如下命令:

# yum -y install bzip2-devel libmcrypt-devel libxml2-devel zlib libxml libjpeg freetype libpng gd  curl libiconv  zlib-devel  libjpeg-devel freetype-devel libpng-devel gd-devel curl-devel 



2、编译安装php-5.4.26
cd /usr/local
编译libiconv库
tar xf libiconv-1.14.tar.gz
cd /usr/local/libiconv-1.14
./configure --prefix=/usr/local/libiconv
cd /usr/local/libiconv-1.14/srclib/ 
sed -i -e '/gets is a security/d' ./stdio.in.h 
cd ../ 
make && make install
cd ../
编译 libmcrypt
tar zxf libmcrypt-2.5.8.tar.gz 
cd libmcrypt-2.5.8
./configure 
make && make install
sleep 2
/sbin/ldconfig 
cd /usr/local/libmcrypt-2.5.8/libltdl/
./configure --enable-ltdl-install
make && make install
cd ../../
编译mash
tar zxf mhash-0.9.9.9.tar.gz 
cd mhash-0.9.9.9/
./configure 
make && make install
sleep 2
cd ../
echo "/usr/local/mhash/lib" > /etc/ld.so.conf.d/mhash.conf
ldconfig -v
编译mcrypt
tar zxf mcrypt-2.6.8.tar.gz 
cd mcrypt-2.6.8
/sbin/ldconfig 
./configure LD_LIBRARY_PATH=/usr/local/lib
make && make install
cd ../
sleep 2


编译PHP


cd /usr/local
tar xf php-5.4.26.tar.bz2

cd php-5.4.26

./configure \
--prefix=/usr/local/php5.5.36 \
--with-apxs2=/usr/local/httpd/bin/apxs \
--with-mysql=/usr/local/mysql \
--with-mysqli=/usr/local/mysql/bin/mysql_config \
--with-xmlrpc \
--with-openssl \
--with-zlib \
--with-freetype-dir \
--with-gd \
--with-jpeg-dir \
--with-png-dir \
--with-iconv=/application/libiconv \
--enable-short-tags \
--enable-sockets \
--enable-zend-signals \
--enable-soap \
--enable-mbstring \
--enable-static \
--enable-gd-native-ttf \
--with-curl \
--with-xsl \
--enable-ftp \
--with-mcrypt \
--with-libxml-dir \
--with-bz2 \
--with-config-file-path=/etc \
--with-config-file-scan-dir=/etc/php.d \
-enable-maintainer-zts 


 ./configure --prefix=/usr/local/php --with-mysql=/usr/local/mysql --with-openssl --with-mysqli=/usr/local/mysql/bin/mysql_config --with-iconv=/usr/local/libiconv --enable-mbstring --with-freetype-dir --with-jpeg-dir --with-png-dir --with-zlib --with-libxml-dir=/usr --enable-xml  --enable-sockets --with-apxs2=/usr/local/httpd/bin/apxs --with-mcrypt  --with-config-file-path=/etc --with-config-file-scan-dir=/etc/php.d --with-bz2  --enable-maintainer-zts 


注:如果mysql是源码编译安装可能会报如下错误
configure: error: Cannot find libmysqlclient under /usr.
Note that the MySQL client library is not bundled anymore!


解决办法
 ./configure --prefix=/usr/local/php --with-mysql=mysqlnd --with-openssl --with-mysqli=mysqlnd --enable-mbstring  --with-freetype-dir --with-jpeg-dir --with-png-dir --with-zlib  --with-libxml-dir=/usr --enable-xml  --enable-sockets --with-apxs2=/usr/local/httpd/bin/apxs --with-mcrypt  --with-config-file-path=/etc --with-config-file-scan-dir=/etc/php.d --with-bz2  --enable-maintainer-zts


说明:
1、这里为了支持apache的worker或event这两个MPM,编译时使用了--enable-maintainer-zts选项。
2、如果使用PHP5.3以上版本,为了链接MySQL数据库,可以指定mysqlnd,这样在本机就不需要先安装MySQL或MySQL开发包了。mysqlnd从php5.3开始可用,可以编译时绑定到它(而不用和具体的MySQL客户端库绑定形成依赖),但从PHP5.4开始它就是默认设置了。
#./configure--with-mysql=mysqlnd--with-pdo-mysql=mysqlnd--with-mysqli=mysqlnd
#make-j8 //用make-j带一个参数,可以把项目在进行并行编译,比如在一台双核的机器上,完全可以用make-j4,让make最多允许4个编译命令同时执行,这样可以更有效的利用CPU资源。
#make-j8test
#make-j8install




为php提供配置文件:
# cp php.ini-production /etc/php.ini




3、 编辑apache配置文件httpd.conf,以apache支持php
 
 # vim /etc/httpd/httpd.conf
 1、添加如下二行
   AddType application/x-httpd-php  .php
   AddType application/x-httpd-php-source  .phps




 2、定位至DirectoryIndex index.html 
   修改为:
    DirectoryIndex  index.php  index.html




而后重新启动httpd,或让其重新载入配置文件即可测试php是否已经可以正常使用。
编辑Apache的网页测试php是否可以连接MySQL、
[root@server1 htdocs]# vim index.php
    <?php
  $conn=mysql_connect('10.1.41.46','root','xuxingzhuang');   
  if ($conn)
        echo "Success...";
  else
        echo "Failure...";
?>


打开浏览器进行web测试访问


# curl 10.1.41.65
Success...
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值